#include "aliases.h"
#include "platform.h"

#ifdef WAPP_PLATFORM_POSIX

#include "terminal_colours.h"
#include "termcolour_posix.h"
#include <stdio.h>

internal const char *colours[COUNT_TERM_COLOUR] = {
    [WAPP_TERM_COLOUR_FG_BLACK]      = "\033[30m",
    [WAPP_TERM_COLOUR_FG_RED]        = "\033[31m",
    [WAPP_TERM_COLOUR_FG_GREEN]      = "\033[32m",
    [WAPP_TERM_COLOUR_FG_BLUE]       = "\033[34m",
    [WAPP_TERM_COLOUR_FG_CYAN]       = "\033[36m",
    [WAPP_TERM_COLOUR_FG_MAGENTA]    = "\033[35m",
    [WAPP_TERM_COLOUR_FG_YELLOW]     = "\033[33m",
    [WAPP_TERM_COLOUR_FG_WHITE]      = "\033[37m",
    [WAPP_TERM_COLOUR_FG_BR_BLACK]   = "\033[90m",
    [WAPP_TERM_COLOUR_FG_BR_RED]     = "\033[91m",
    [WAPP_TERM_COLOUR_FG_BR_GREEN]   = "\033[92m",
    [WAPP_TERM_COLOUR_FG_BR_BLUE]    = "\033[94m",
    [WAPP_TERM_COLOUR_FG_BR_CYAN]    = "\033[96m",
    [WAPP_TERM_COLOUR_FG_BR_MAGENTA] = "\033[95m",
    [WAPP_TERM_COLOUR_FG_BR_YELLOW]  = "\033[93m",
    [WAPP_TERM_COLOUR_FG_BR_WHITE]   = "\033[97m",
    [WAPP_TERM_COLOUR_CLEAR]         = "\033[0m",
};

void print_coloured_text(const char *text, TerminalColour colour) {
  printf("%s%s", colours[colour], text);
}

#endif // !WAPP_PLATFORM_POSIX
