#include "test_allocator.h"
#include "libc/mem_libc_allocator.h"
#include "mem_allocator.h"
#include "mem_arena_allocator.h"
#include "tester.h"
#include <stdbool.h>
#include <stdlib.h>

TestFuncResult test_libc_allocator(void) {
  Allocator allocator = wapp_mem_libc_allocator();
  bool result         = allocator.obj == NULL && allocator.alloc != NULL &&
                        allocator.alloc_aligned != NULL && allocator.realloc != NULL &&
                        allocator.realloc_aligned == NULL && allocator.free != NULL;
  void *ptr           = wapp_mem_allocator_alloc(&allocator, 20);
  result              = result && (ptr != NULL);

  if (ptr != NULL) {
    wapp_mem_allocator_free(&allocator, &ptr);
    result = result && (ptr == NULL);
  }

  return wapp_tester_result(result);
}

TestFuncResult test_arena_allocator(void) {
  Allocator allocator = wapp_mem_arena_allocator_init(4096);
  bool result         = allocator.obj != NULL && allocator.alloc != NULL &&
                        allocator.alloc_aligned != NULL &&
                        allocator.realloc != NULL & allocator.realloc_aligned != NULL &&
                        allocator.free == NULL;
  void *ptr           = wapp_mem_allocator_alloc(&allocator, 20);
  result              = result && (ptr != NULL);

  wapp_mem_arena_allocator_destroy(&allocator);

  return wapp_tester_result(result);
}
